package matrix;

import java.util.List;

/**
 * 题目：59. 螺旋矩阵 II (generateMatrix)
 * 描述：给你一个正整数 n ，生成一个包含 1 到 n2 所有元素，且元素按顺时针顺序螺旋排列的 n x n 正方形矩阵 matrix 。
 *

 * 示例 1：
 输入：n = 3
 输出：[[1,2,3],[8,9,4],[7,6,5]]

 * 链接：https://leetcode.cn/problems/spiral-matrix-ii/
 */
public class GenerateMatrix {
    public int[][] generateMatrix(int n) {
        int[][]res=new int[n][n];
        int index=1;
        int top=0,left=0,right=n-1,bottom=n-1;
        while (top<=bottom&&left<=right){
            for (int i = left; i <= right; i++) {
                res[top][i]=index;
                index++;
            }
            top++;
            for (int i = top; i <= bottom; i++) {
                res[i][right]=index;
                index++;
            }
            right--;
            if (top <= bottom) {
                for (int i = right; i >= left; i--) {
                    res[bottom][i] = index;
                    index++;
                }
                bottom--;
            }
            if(left <= right) {
                for (int i = bottom; i >= top; i--) {
                    res[i][left] = index;
                    index++;
                }
                left++;
            }
        }
        return res;
    }
}
