package string;
/**
 * 题目： 459. 重复的子字符串 (repeatedSubstringPattern)
 * 描述：给定一个非空的字符串 s ，检查是否可以通过由它的一个子串重复多次构成。
 *
 * 示例 1：
 输入: s = "abab"
 输出: true
 解释: 可由子串 "ab" 重复两次构成。

 * 链接：https://leetcode.cn/problems/reverse-string-ii/
 */
public class RepeatedSubstringPattern {
    public boolean repeatedSubstringPattern(String s) {
        int len = s.length();
        for (int j = 1; j <= len / 2; j++) {
            if (len % j != 0) continue;        // ★ 只有能整除时才有可能
            String tp = s.substring(0, j);
            boolean flag = true;
            for (int i = j; i < len; i += j) {
                if (!s.substring(i, i + j).equals(tp)) {
                    flag = false;
                    break;
                }
            }
            if (flag) return true;
        }
        return false;
    }
}
