package tree;
import java.util.LinkedList;
import java.util.Queue;

/**
 * 题目： 513. 找树左下角的值 (FindBottomLeftValue )
 * 描述：给定一个二叉树的 根节点 root，请找出该二叉树的 最底层 最左边 节点的值。
 * 假设二叉树中至少有一个节点。
 *
 * 示例 1：
 输入: root = [2,1,3]
 输出: 1

 * 链接：https://leetcode.cn/problems/find-bottom-left-tree-value/
 */
public class FindBottomLeftValue {
    public int findBottomLeftValue(TreeNode root) {
        int res=Integer.MIN_VALUE;
        Queue<TreeNode>queue=new LinkedList<>();
        queue.offer(root);
        while (!queue.isEmpty()){
            int sz=queue.size();
            boolean flag=false;
            for (int i = 0; i < sz; i++) {
                TreeNode cur=queue.poll();
                if(i==0)res=cur.val;
                if(cur.left!=null) {
                    queue.add(cur.left);
                    flag=true;
                }
                if(cur.right!=null){
                    queue.add(cur.right);
                    flag=true;
                }
            }
            if(!flag)return res;
        }
        return res;
    }
}
